Package org.apache.bcel.verifier

# Class PassVerifier

java.lang.Object
org.apache.bcel.verifier.PassVerifier

Direct Known Subclasses:
  `Pass1Verifier`, `Pass2Verifier`, `Pass3aVerifier`, `Pass3bVerifier`

public abstract class PassVerifier extends Object
A PassVerifier actually verifies a class file; it is instantiated by a Verifier. The verification should conform with a certain pass as described in The Java Virtual Machine Specification, 2nd edition. This book describes four passes. Pass one means loading the class and verifying a few static constraints. Pass two actually verifies some other constraints that could enforce loading in referenced class files. Pass three is the first pass that actually checks constraints in the code array of a method in the class file; it has two parts with the first verifying static constraints and the second part verifying structural constraints (where a data flow analysis is used for). The fourth pass, finally, performs checks that can only be done at run-time. JustIce does not have a run-time pass, but certain constraints that are usually delayed until run-time for performance reasons are also checked during the second part of pass three. PassVerifier instances perform caching. That means, if you really want a new verification run of a certain pass you must use a new instance of a given PassVerifier.

See Also:
  - `Verifier`
  - `verify()`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `PassVerifier()`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `addMessage(String message)`
  This method adds a (warning) message to the message pool of this PassVerifier.
  `abstract VerificationResult`
  `do_verify()`
  Verifies, not cached.
  `String[]`
  `getMessages()`
  Returns the (warning) messages that this PassVerifier accumulated during its do_verify()ing work.
  `List<String>`
  `getMessagesList()`
  Returns the (warning) messages that this PassVerifier accumulated during its do_verify()ing work.
  `VerificationResult`
  `verify()`
  This method runs a verification pass conforming to the Java Virtual Machine Specification, 2nd edition, on a class file.

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Constructor Details

  - ### PassVerifier

    public PassVerifier()

- ## Method Details

  - ### addMessage

    public void addMessage(String message)
    This method adds a (warning) message to the message pool of this PassVerifier. This method is normally only internally used by BCEL's class file verifier "JustIce" and should not be used from the outside.
    Parameters:
      `message` - message to be appended to the message list.
    See Also:
      - `getMessages()`

  - ### do_verify

    public abstract VerificationResult do_verify()
    Verifies, not cached.
    Returns:
      The VerificationResult

  - ### getMessages

    public String[] getMessages()
    Returns the (warning) messages that this PassVerifier accumulated during its do_verify()ing work.
    Returns:
      the (warning) messages.
    See Also:
      - `addMessage(String)`
      - `do_verify()`

  - ### getMessagesList

    public List<String> getMessagesList()
    Returns the (warning) messages that this PassVerifier accumulated during its do_verify()ing work.
    See Also:
      - `addMessage(String)`
      - `do_verify()`

  - ### verify

    public VerificationResult verify()
    This method runs a verification pass conforming to the Java Virtual Machine Specification, 2nd edition, on a class file. PassVerifier instances perform caching; i.e. if the verify() method once determined a VerificationResult, then this result may be returned after every invocation of this method instead of running the verification pass anew; likewise with the result of getMessages().
    Returns:
      a VerificationResult.
    See Also:
      - `getMessages()`
      - `addMessage(String)`